<template>
  <SfModal class="sw-gs-device-error-modal" :visible="true" :overlay="true" :cross="false">

    <div class="sw-gs-device-error-modal-error">
      <template v-if="deviceError === 'NO_DEVICES_FOUND'">
        <div class="sw-gs-device-error-modal-error-headline">{{ $t('No devices found') }}</div>
        <div class="sw-gs-device-error-modal-error-content">

          <p>
            {{ $t('No microphone/camera detected') }}<br/>
            {{ $t('Make sure your devices are connected and try again.') }}
          <p>

          <p>{{ $t('Or your browser needs camera and microphone access:') }}</p>
          <ol>
            <li>{{ $t('Click the camera icon in your browsers address bar or go to your browser settings.') }}</li>
            <li>{{ $t('Select "Always allow", then click done.') }}</li>
            <li>{{ $t('Refresh the page.') }}</li>
          </ol>
        </div>
      </template>

      <template v-if="deviceError === 'CAMERA_IN_USE'">
        <div class="sw-gs-device-error-modal-error-headline">{{ $t('Another app is using your camera') }}</div>
        <div class="sw-gs-device-error-modal-error-content">{{ $t('Select a different camera or quit the app and reload this call to use your camera in this call.') }}</div>
      </template>

      <template v-if="deviceError === 'MICROPHONE_IN_USE'">
        <div class="sw-gs-device-error-modal-error-headline">{{ $t('Another app is using your microphone') }}</div>
        <div class="sw-gs-device-error-modal-error-content">{{ $t('Select a different microphone or quit the app and reload this call to use your microphone in this call.') }}</div>
      </template>

      <template v-if="deviceError === 'CAMERA_AND_MICROPHONE_IN_USE'">
        <div class="sw-gs-device-error-modal-error-headline">{{ $t('Another app is using your microphone and camera') }}</div>
        <div class="sw-gs-device-error-modal-error-content">{{ $t('Select a different microphone and camera or quit the app and reload this call to use your microphone and camera in this call.') }}</div>
      </template>

      <template v-if="deviceError === 'SPEAKER_NOT_ALLOWED'">
        <div class="sw-gs-device-error-modal-error-headline">{{ $t('Allow Speaker') }}</div>
        <div class="sw-gs-device-error-modal-error-content">{{ $t('Your Browser needs special allowance for speaker output. Please press this button to give it.') }}</div>
      </template>
    </div>

    <div class="sw-gs-device-error-modal-btn-wrapper">
      <template v-if="deviceError === 'SPEAKER_NOT_ALLOWED'">
        <SwButton class="sw-gs-device-error-modal-close-btn color-light" @click="onAllowSpeaker()">
          {{$t('Allow Speaker')}}
        </SwButton>
      </template>
      <template v-else>
        <SwButton class="sw-gs-device-error-modal-close-btn color-light" @click="onAudioOnly()">
          {{$t('Join with audio only')}}
        </SwButton>

        <SwButton class="sw-gs-device-error-modal-reload-btn color-success" @click="reloadPage()">
          {{ $t("Refresh page") }}
        </SwButton>
      </template>
    </div>

  </SfModal>
</template>

<script lang="ts">
  import { SfModal } from "@storefront-ui/vue";
  import SwButton from "@/components/atoms/SwButton.vue";
  import { useMediaDevices } from '../../logic/composables/useMediaDevices';
  import { useVideoCall } from '../../logic/composables/useVideoCall';
  import { useClearBodyScrollLock } from "../../logic/composables/useClearBodyScrollLock";

  export default {
    name: "SwGsDeviceErrorModal",
    components: {
      SfModal,
      SwButton
    },
    setup() {
      const { unsetDevicesFromStorage, deviceError, unsetDeviceError, saveDevicesToStorage, setAudioOnly } = useMediaDevices();
      const { toggleCamera, unlockSpeakerAudio, updateCallDevice } = useVideoCall();

      useClearBodyScrollLock();

      const reloadPage = () => {
        unsetDevicesFromStorage();
        setTimeout(() => {
          location.reload()
        }, 250);
      };

      const onAudioOnly = () => {
        setAudioOnly();
        toggleCamera(false);
        updateCallDevice('camera-device', false);
        saveDevicesToStorage();
        setTimeout(() => {
          unsetDeviceError();
        }, 250);
      };

      const onAllowSpeaker = () => {
        unlockSpeakerAudio();
        saveDevicesToStorage();
        setTimeout(() => {
          unsetDeviceError();
        }, 250);
      };

      return {
        deviceError,
        reloadPage,
        onAudioOnly,
        onAllowSpeaker,
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";


  .sw-gs-device-error-modal {
    ::v-deep {
      .sf-modal__overlay {
        z-index: var(--top-modal-overlay-z-index);
      }

      .sf-modal__container {
        z-index: var(--top-modal-container-z-index);
        width: 630px !important;
        min-width: 630px;
      }
    }

    .sw-gs-device-error-modal-error {
      display: flex;
      flex-direction: column;
    }

    .sw-gs-device-error-modal-error-headline {
      font-weight: bold;
    }

    .sw-gs-device-error-modal-error-content {
      ol {
        padding-left: 20px;
        max-width: 80%;
      }
    }
  }


  .sw-gs-device-error-modal-btn-wrapper {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
  }

</style>
